"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var rxjs_1 = require("rxjs");
var ScriptService = /** @class */ (function () {
    function ScriptService() {
    }
    ScriptService.prototype.load = function (src, target) {
        var _this = this;
        this.isReady = false;
        this.src = src;
        var body = document.querySelector('body');
        this.useScript = new rxjs_1.Subject();
        // filter loaded scripts (use script service loaed)
        var scripts = document.querySelectorAll('script');
        for (var i = 0; i < scripts.length; i++) {
            if (scripts[i].getAttribute('src') === src) {
                if (scripts[i].getAttribute('complete') === 'complete') {
                    this.isReady = true;
                    this.useScript.complete();
                }
                else {
                    scripts[i].addEventListener('load', function () {
                        _this.isReady = true;
                        _this.useScript.complete();
                    });
                }
                return;
            }
        }
        // is loaded from other
        if (target) {
            this.isReady = true;
            this.useScript.complete();
        }
        else {
            var node_1 = document.createElement('script');
            node_1.async = true;
            node_1.type = 'text/javascript';
            node_1.src = src;
            node_1.charset = 'utf-8';
            document.getElementsByTagName('head')[0].appendChild(node_1);
            node_1.addEventListener('load', function () {
                _this.isReady = true;
                _this.useScript.complete();
                node_1.setAttribute('complete', 'complete');
            });
        }
        return this.useScript;
    };
    ScriptService.prototype.task = function (src) {
        return rxjs_1.Observable.create(function (observer) {
            var node = document.createElement('script');
            node.async = true;
            node.type = 'text/javascript';
            node.src = src;
            node.charset = 'utf-8';
            document.getElementsByTagName('head')[0].appendChild(node);
            node.addEventListener('load', function () {
                observer.complete();
            });
        });
    };
    ScriptService.prototype.loads = function (srcs, test) {
        var _this = this;
        if (test === void 0) { test = false; }
        this.isReady = false;
        this.useScript = new rxjs_1.Subject();
        var taskArray = new Array();
        if (test) {
            this.isReady = true;
            this.useScript.complete();
        }
        srcs.forEach(function (src) {
            taskArray.push(_this.task(src));
        });
        rxjs_1.concat.apply(void 0, taskArray).subscribe({
            complete: function () { _this.useScript.complete(); }
        });
        return this.useScript;
    };
    ScriptService.prototype.complete = function (func) {
        this.useScript.subscribe({ complete: function () { return func(); } });
    };
    ScriptService.decorators = [
        { type: core_1.Injectable },
    ];
    return ScriptService;
}());
exports.ScriptService = ScriptService;
//# sourceMappingURL=script.service.js.map