"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var radio_component_1 = require("./radio.component");
var forms_1 = require("@angular/forms");
var RadiosDirective = /** @class */ (function () {
    function RadiosDirective(cdRef) {
        this.cdRef = cdRef;
        this.applyChange = function (value) { };
        this.isReady = false;
    }
    RadiosDirective.prototype.ngAfterViewInit = function () {
        this.isReady = true;
    };
    RadiosDirective.prototype.replyValue = function () {
        var radioList = this.radioList.toArray();
        for (var i = 0; i < this.radioList.length; i++) {
            if (radioList[i].value === this.value) {
                radioList[i].checked = true;
            }
            else {
                radioList[i].checked = false;
            }
        }
        this.cdRef.detectChanges();
    };
    RadiosDirective.prototype.writeValue = function (value) {
        this.value = value;
        if (this.isReady) {
            this.replyValue();
        }
    };
    RadiosDirective.prototype.registerOnChange = function (fn) { this.applyChange = fn; };
    RadiosDirective.prototype.registerOnTouched = function (fn) { };
    RadiosDirective.prototype.applyRadioValue = function () {
        var _this = this;
        var radioList = this.radioList.toArray();
        radioList.forEach(function (radio) {
            if (_this.value !== radio.value) {
                radio.checked = false;
            }
        });
        this.cdRef.detectChanges();
    };
    RadiosDirective.prototype.applyRadioChange = function (handle) {
        if (handle.value !== undefined) {
            this.value = handle.checked === true ? handle.value : null;
            this.applyChange(this.value);
        }
        else if (handle.checked === true) {
            this.value = null;
            this.applyChange(this.value);
        }
        this.applyRadioValue();
    };
    RadiosDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '*[tsRadioGroup]',
                    exportAs: 'tsRadioGroup',
                    providers: [{
                            provide: forms_1.NG_VALUE_ACCESSOR,
                            useExisting: core_1.forwardRef(function () { return RadiosDirective; }),
                            multi: true
                        }]
                },] },
    ];
    /** @nocollapse */
    RadiosDirective.ctorParameters = function () { return [
        { type: core_1.ChangeDetectorRef, },
    ]; };
    RadiosDirective.propDecorators = {
        "radioList": [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return radio_component_1.RadioComponent; }),] },],
    };
    return RadiosDirective;
}());
exports.RadiosDirective = RadiosDirective;
//# sourceMappingURL=radios.direvtive.js.map