"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var htmldom_service_1 = require("./../../commons/services/htmldom.service");
var CollapseDirective = /** @class */ (function () {
    function CollapseDirective(elementRef, htmlDomService) {
        this.elementRef = elementRef;
        this.htmlDomService = htmlDomService;
        this.stateChange = new core_1.EventEmitter();
        this.open = false;
        this.isReady = false;
    }
    CollapseDirective.prototype.ngOnChanges = function () {
        if (this.isReady) {
            this.open ? this.collapseOpen() : this.collapseClose();
        }
    };
    CollapseDirective.prototype.ngAfterViewInit = function () {
        this.pad = this.elementRef.nativeElement;
        this.pad.style.transition = 'height .35s ease';
        this.pad.style.overflow += 'hidden';
        this.open ? this.collapseOpen() : this.collapseClose();
        this.isReady = true;
    };
    CollapseDirective.prototype.collapseClose = function () {
        var _this = this;
        this.open = false;
        var height = this.htmlDomService.getExpHeight(this.pad);
        this.pad.style.height = height + 'px';
        setTimeout(function () { _this.pad.style.height = '0px'; }, 100);
        this.stateChange.emit(this.open);
    };
    CollapseDirective.prototype.collapseOpen = function () {
        var _this = this;
        this.open = true;
        this.pad.style.height = '';
        var height = this.htmlDomService.getExpHeight(this.pad);
        this.pad.style.height = '0px';
        setTimeout(function () { _this.pad.style.height = height + 'px'; });
        setTimeout(function () { _this.pad.style.height = ''; }, 350);
        this.stateChange.emit(this.open);
    };
    CollapseDirective.prototype.toggle = function () {
        this.open ? this.collapseClose() : this.collapseOpen();
    };
    CollapseDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '*[tsCollapse]',
                    exportAs: 'tsCollapse',
                },] },
    ];
    /** @nocollapse */
    CollapseDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: htmldom_service_1.HtmlDomService, },
    ]; };
    CollapseDirective.propDecorators = {
        "open": [{ type: core_1.Input },],
        "stateChange": [{ type: core_1.Output },],
    };
    return CollapseDirective;
}());
exports.CollapseDirective = CollapseDirective;
//# sourceMappingURL=collapse.directive.js.map