import { Injector, ApplicationRef, ComponentFactoryResolver } from '@angular/core';
import { ConfirmConfig } from './confirm.data';
import { Observable } from 'rxjs';
export declare class ConfirmService {
    private applicationRef;
    private componentFactoryResolver;
    private injector;
    private options;
    private baseComponent;
    private windowCmptRef;
    constructor(applicationRef: ApplicationRef, componentFactoryResolver: ComponentFactoryResolver, injector: Injector, options: ConfirmConfig);
    private init();
    create(title: string, message: string, options: {
        okTitle?: string;
        cancelTitle?: string;
        color?: string;
    }): Observable<void>;
    info(title: string, message: string, options?: {
        okTitle?: string;
        cancelTitle?: string;
    }): Observable<void>;
    warning(title: string, message: string, options?: {
        okTitle?: string;
        cancelTitle?: string;
    }): Observable<void>;
    danger(title: string, message: string, options?: {
        okTitle?: string;
        cancelTitle?: string;
    }): Observable<void>;
    success(title: string, message: string, options?: {
        okTitle?: string;
        cancelTitle?: string;
    }): Observable<void>;
    combineOptions(options: {
        okTitle?: string;
        cancelTitle?: string;
    }): any;
}
