import { ElementRef, OnDestroy } from '@angular/core';
import { HtmlDomService } from '../../commons/services/htmldom.service';
import { DomAttr } from '../../commons/extends/attr.class';
import { Toggle } from '../../commons/interfaces/toggle.interface';
import { ToggleDirective } from '../../commons/directives/toggle.directives';
import { ControlValueAccessor } from '@angular/forms';
export declare class DatepickerComponent extends DomAttr implements OnDestroy, Toggle, ControlValueAccessor {
    private html;
    weekTitles: string[];
    monthTitles: string[];
    activeClass: string;
    toggleTarget: ToggleDirective;
    pad: ElementRef;
    datepicker: ElementRef;
    year: number;
    month: number;
    day: number;
    show: boolean;
    toggleDom: HTMLElement;
    ticking: boolean;
    datepickerStyle: {
        top: string;
        left: string;
        display: string;
        position: string;
    };
    private value;
    autoHandle: () => void;
    applyChange: (value: any) => void;
    readonly days: number[];
    readonly trList: Array<number[]>;
    readonly yearList: Array<number>;
    constructor(html: HtmlDomService);
    ngOnDestroy(): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    getMonth(month: number): string;
    setDay(day: number): void;
    setValue(): void;
    isActiveDay(day: number): boolean;
    nextMonth(): void;
    prevMonth(): void;
    nextYear(): void;
    prevYear(): void;
    toggle(): void;
    bind(toggleDirective: ToggleDirective): void;
    autoPosition(): void;
    tryClose($event: any): void;
    trackByFn(item: any): number;
}
