"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var LoopCardComponent = /** @class */ (function () {
    function LoopCardComponent(sanitizer) {
        this.sanitizer = sanitizer;
        this.cardSave = new core_1.EventEmitter();
        this.cardRemove = new core_1.EventEmitter();
        this.config = {
            host: '',
            saveTitle: 'Save',
            removeTitle: 'Remove',
            successTitle: 'success',
            warningTitle: 'warning',
            textTitle: 'Link',
            defaultBackground: '',
        };
    }
    Object.defineProperty(LoopCardComponent.prototype, "realSrc", {
        get: function () {
            return typeof this.loopCard.src === 'string' ? (this.loopCard.src ? this.config.host + this.loopCard.src : '') : this.loopCard.src;
        },
        enumerable: true,
        configurable: true
    });
    LoopCardComponent.prototype.changeFile = function (files) {
        if (files && files.length > 0) {
            this.loopCard.active = false;
            this.loopCard.file = files[0];
            this.loopCard.src = this.sanitizer.bypassSecurityTrustResourceUrl(window.URL.createObjectURL(this.loopCard.file));
        }
    };
    LoopCardComponent.prototype.save = function () {
        this.cardSave.emit(this.loopCard);
    };
    LoopCardComponent.prototype.remove = function () {
        this.cardRemove.emit(this.loopCard);
    };
    LoopCardComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-loop-card',
                    template: "\n    <div class=\"card rounded-0 p-2 d-inline-block m-1\" style=\"width:20rem;\">\n        <input #file type=\"file\" style=\"display:none\" accept=\"image/*\" (change)=\"changeFile($event.target.files)\">\n        <img (click)=\"file.click()\" class=\"card-img-top pointer\" [src]=\"realSrc||config.defaultBackground\" style=\"height:10rem;width:100%;\">\n        <hr style=\"width:100%;\" class=\"mt-2 mb-0\">\n        <div class=\"input-group input-group-sm mt-2\">\n            <div class=\"input-group-prepend\">\n                <span class=\"input-group-text bg-white\">{{config.textTitle}}</span>\n            </div>\n            <input (ngModelChange)=\"loopCard.active=false\"\n            name=\"url\" [(ngModel)]=\"loopCard.url\" type=\"text\" class=\"form-control\" placeholder=\"\u8BF7\u8F93\u5165\u94FE\u63A5\u5730\u5740\">\n        </div>\n        <div class=\"text-right mt-2\">\n            <span [class.d-none]=\"loopCard.active === true\" class=\"pull-left badge badge-danger\">{{config.warningTitle}}</span>\n            <span [class.d-none]=\"loopCard.active !== true\" class=\"pull-left badge badge-success\">{{config.successTitle}}</span>\n            <button (click)=\"save()\" type=\"button\" class=\"btn btn-sm btn-info\">\n                <i class=\"fa fa-check fa-fw\"></i>{{config.saveTitle}}</button>\n            <button (click)=\"remove()\" type=\"button\" class=\"btn btn-sm btn-danger\">\n                <i class=\"fa fa-close fa-fw\"></i>{{config.removeTitle}}</button>\n        </div>\n    </div>"
                },] },
    ];
    /** @nocollapse */
    LoopCardComponent.ctorParameters = function () { return [
        { type: platform_browser_1.DomSanitizer, },
    ]; };
    LoopCardComponent.propDecorators = {
        "loopCard": [{ type: core_1.Input },],
        "config": [{ type: core_1.Input },],
        "cardSave": [{ type: core_1.Output },],
        "cardRemove": [{ type: core_1.Output },],
    };
    return LoopCardComponent;
}());
exports.LoopCardComponent = LoopCardComponent;
//# sourceMappingURL=loop-card.component.js.map