"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var MenuPushService = /** @class */ (function () {
    function MenuPushService() {
        this._items = new Array();
        this.maxItemNum = 6;
    }
    Object.defineProperty(MenuPushService.prototype, "items", {
        get: function () {
            if (this._items.length > this.maxItemNum) {
                this._items.shift();
            }
            return !!this.defaultItem ? [this.defaultItem].concat(this._items) : this._items;
        },
        enumerable: true,
        configurable: true
    });
    MenuPushService.prototype.push = function () {
        var _this = this;
        var items = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            items[_i] = arguments[_i];
        }
        items.forEach(function (item) {
            _this._items.push({
                title: item.title,
                url: item.url,
                active: false,
            });
        });
    };
    MenuPushService.prototype.setActive = function (item) {
        this.cleanAllActive();
        if (!!this.defaultItem && this.defaultItem.url === item.url && this.defaultItem.title === item.title) {
            this.defaultItem.active = true;
        }
        else {
            var index = this._items.findIndex(function (e) { return e.url === item.url && e.title === item.title; });
            if (index >= 0) {
                this._items[index].active = true;
            }
            else {
                this.push(item);
                this._items[this._items.length - 1].active = true;
            }
            if (!!this.defaultItem) {
                this.defaultItem.active = false;
            }
        }
    };
    MenuPushService.prototype.cleanAllActive = function () {
        this._items.forEach(function (item) { return item.active = false; });
    };
    MenuPushService.prototype.setMaxItemNum = function (maxItemNum) {
        this.maxItemNum = maxItemNum;
    };
    MenuPushService.prototype.setDefaultItem = function (item) {
        this.defaultItem = item;
    };
    MenuPushService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    MenuPushService.ctorParameters = function () { return []; };
    return MenuPushService;
}());
exports.MenuPushService = MenuPushService;
//# sourceMappingURL=menu-push.service.js.map