"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("../../commons/extends/attr.class");
var MenuComponent = /** @class */ (function (_super) {
    __extends(MenuComponent, _super);
    function MenuComponent() {
        var _this = _super.call(this) || this;
        _this.menuActiveChange = new core_1.EventEmitter();
        _this.items = new Array();
        _this.config = { BACKGROUND_IMAGE_SRC: '' };
        return _this;
    }
    Object.defineProperty(MenuComponent.prototype, "activeMainClass", {
        get: function () {
            return this.borderClass + " bg-" + this.color + "-fill";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MenuComponent.prototype, "activeParentClass", {
        get: function () {
            return "" + this.textClass;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MenuComponent.prototype, "activeChildClass", {
        get: function () {
            return "" + this.textClass;
        },
        enumerable: true,
        configurable: true
    });
    MenuComponent.prototype.toggleGroup = function (group) {
        var tempActive = group.active;
        this.setAllInActive();
        group.active = !tempActive;
    };
    MenuComponent.prototype.toggleMenu = function (group, itemIndex) {
        this.setAllInActive();
        group.active = true;
        group.menuItems[itemIndex].active = true;
        this.menuActiveChange.emit(group.menuItems[itemIndex]);
    };
    MenuComponent.prototype.setActive = function (menu) {
        this.setAllInActive();
        for (var i = 0; i < this.items.length; i++) {
            for (var j = 0; j < this.items[i].menuGroups.length; j++) {
                for (var k = 0; k < this.items[i].menuGroups[j].menuItems.length; k++) {
                    var temp = this.items[i].menuGroups[j].menuItems[k];
                    if (temp.title === menu.title && temp.url === menu.url) {
                        temp.active = true;
                        temp.targetGroup.active = true;
                    }
                }
            }
        }
    };
    MenuComponent.prototype.setAllInActive = function () {
        this.items.forEach(function (item) {
            item.menuGroups.forEach(function (a) {
                a.active = false;
                a.menuItems.forEach(function (b) {
                    b.active = false;
                });
            });
        });
    };
    MenuComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "ts-menu",
                    exportAs: 'tsMenu',
                    template: "\n    <div class=\"h-100 menu-bg\" [ngStyle]=\"{backgroundImage:config.BACKGROUND_IMAGE_SRC}\">\n        <div class=\"h-100 w-100 pt-2\" [ngStyle]=\"{backgroundColor:config.BACKGROUND_COLOR,color:config.DEFAULT_TEXT_COLOR}\">\n            <div class=\"media pl-3 mb-3 pt-3\" *ngIf=\"avatars\">\n                <img class=\"mr-2 rounded-circle\" [src]=\"avatars[0]\" height=\"40\" width=\"40\" alt=\"Avatar \">\n                <div class=\"media-body\">\n                    <h6 class=\"mt-0 mb-0 d-inline-block font-weight-bold\">{{avatars[1]}}</h6>\n                    <p class=\"mb-0 d-inline-block\">{{avatars[2]}}</p>\n                </div>\n            </div>\n            <!--<hr *ngIf=\"avatars\" class=\"mt-0 mb-2 ml-3 mr-3\">-->\n            <ng-container *ngFor=\"let model of items;\">\n                <!--<h5 class=\"model-title mb-1 pt-2 mt-1 pl-3\">{{model.modelTitle | titlecase}}</h5>-->\n                <hr class=\"mt-0 mb-2 ml-1 mr-1\" [ngStyle]=\"{borderColor:config.LINE_COLOR}\">\n                <div class=\"menu-block {{group.active?activeMainClass:''}}\" *ngFor=\"let group of model.menuGroups\">\n                    <div class=\"menu-main pointer pl-2 pr-3 {{group.active?activeParentClass:''}}\" (click)=\"toggleGroup(group)\">\n                        <div class=\"d-table w-100 pb-1\">\n                            <div class=\"d-table-cell text-center ts-icon\">\n                                <i [class]=\"group.icon\" aria-hidden=\"true\"></i>\n                            </div>\n                            <div class=\"d-table-cell pl-3\">\n                                <span>{{group.groupTitle | titlecase}}</span>\n                            </div>\n                            <div class=\"d-table-cell text-right pr-2\">\n                                <i class=\"fa fa-caret-down ts-icon-sm\" aria-hidden=\"true\"\n                                [class.icon-up]=\"group.active\" [class.icon-down]=\"!group.active\"></i>\n                            </div>\n                        </div>\n                    </div>\n                    <div class=\"menu-child-block\" [class.child-open]=\"group.active\" [class.child-close]=\"!group.active\">\n                        <div class=\"menu-child-item\" *ngFor=\"let item of group.menuItems;index as i\">\n                            <div class=\"d-table w-100 pl-2 pointer {{item.active?activeChildClass:''}}\" (click)=\"toggleMenu(group,i)\">\n                                <div class=\"d-table-cell text-center ts-icon\">\n                                    <i class=\"fa fa-angle-right\"></i>\n                                </div>\n                                <div class=\"d-table-cell pl-3\">\n                                    <span>{{item.title}}</span>\n                                </div>\n                            </div>\n                        </div>\n                    </div>\n                </div>\n            </ng-container>\n            <div class=\"menu-temp-bar\"></div>\n        </div>\n    </div>",
                    styles: [
                        "\n        .menu-bg{\n            background-size:cover;\n        }\n        .ts-icon-sm{\n            font-size:11px;\n        }\n        .ts-icon{\n            width:30px;\n        }\n        .icon-up {\n            animation: icon-up 0.5s ease-out forwards;\n        }\n        .icon-down {\n            animation: icon-down 0.5s ease-out forwards;\n        }\n        .model-title{\n            opacity: 0.8;\n        }\n        .menu-block {\n            overflow-y: hidden;\n            -moz-user-select: none;\n            -webkit-user-select: none;\n            -ms-user-select: none;\n            -khtml-user-select: none;\n            user-select: none;\n            border-left-width:3px;\n            border-left-style:solid;\n            border-left-color:transparent;\n        }\n        .menu-main{\n            line-height:42px;\n        }\n        .menu-child-block{\n            line-height:42px;\n        }\n        .menu-child-item:hover{\n            background-color:#343a4011;;\n        }\n        .child-close {\n            max-height: 0px;\n            opacity: 0.5;\n            transform-origin: 50% 0%;\n            transition: all 0.5s linear;\n        }\n        .child-open {\n            max-height: 400px;\n            opacity: 1;\n            transform-origin: 50% 0%;\n            transition: all 1.5s linear;\n        }\n        @keyframes icon-up {\n            0% {\n                transform: rotate(0deg);\n            }\n            100% {\n                transform: rotate(180deg);\n            }\n        }\n        @keyframes icon-down {\n            0% {\n                transform: rotate(180deg);\n            }\n            100% {\n                transform: rotate(0deg);\n            }\n        }\n        .menu-temp-bar{\n            height:60px;\n        }\n        .bg-primary-fill{\n            background-color:#007bff11;\n        }\n        .bg-secondary-fill{\n            background-color:#6c757d11;\n        }\n        .bg-success-fill{\n            background-color:#28a74511;\n        }\n        .bg-danger-fill{\n            background-color:#dc354511;\n        }\n        .bg-warning-fill{\n            background-color:#ffc10711;\n        }\n        .bg-dark-fill{\n            background-color:#343a4011;\n        }\n        .bg-info-fill{\n            background-color:#17a2b811;\n        }\n        .bg-light-fill{\n            background-color:#ffffff22;\n        }\n        ",
                    ]
                },] },
    ];
    /** @nocollapse */
    MenuComponent.ctorParameters = function () { return []; };
    MenuComponent.propDecorators = {
        "items": [{ type: core_1.Input },],
        "avatars": [{ type: core_1.Input },],
        "config": [{ type: core_1.Input },],
        "menuActiveChange": [{ type: core_1.Output },],
    };
    return MenuComponent;
}(attr_class_1.DomAttr));
exports.MenuComponent = MenuComponent;
//# sourceMappingURL=menu.component.js.map