"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var pagination_class_1 = require("./pagination.class");
var attr_class_1 = require("./../../commons/extends/attr.class");
var PaginationComponent = /** @class */ (function (_super) {
    __extends(PaginationComponent, _super);
    function PaginationComponent() {
        var _this = _super.call(this) || this;
        _this.pageChange = new core_1.EventEmitter();
        _this.goTitle = '';
        _this.btnNum = 5;
        _this.pagination = new pagination_class_1.Pagination();
        return _this;
    }
    PaginationComponent.prototype.ngDoCheck = function () { this.setPages(); };
    PaginationComponent.prototype.changeLimit = function (limit) {
        this.pagination.limit = limit;
        this.setPages();
        this.pageChange.emit(this.pagination);
    };
    PaginationComponent.prototype.sendChange = function (page) {
        if (page && this.pagination.hasPage(page)) {
            this.pagination.page = page;
            this.setPages();
            this.pageChange.emit(this.pagination);
        }
        else {
            this.pageChange.emit(this.pagination);
        }
    };
    PaginationComponent.prototype.setPages = function () {
        if (!this.pagination.pageValid()) {
            this.pagination.page = 1;
        }
        this.pages = [];
        var pagination = this.pagination.clone();
        var right = 0;
        var left = 0;
        var maxLeftNum = pagination.page - 1;
        var maxRightNum = pagination.maxPage - pagination.page;
        maxRightNum = maxRightNum > 0 ? maxRightNum : 0;
        var expLeftNum = Math.ceil((this.btnNum - 1) / 2);
        var expRightNum = this.btnNum - expLeftNum - 1;
        if (maxLeftNum >= expLeftNum) {
            if (maxRightNum >= expRightNum) {
                left = expLeftNum;
                right = expRightNum;
            }
            else {
                right = maxRightNum;
                left = maxLeftNum > (this.btnNum - right - 1) ? this.btnNum - right - 1 : maxLeftNum;
            }
        }
        else {
            if (maxRightNum >= expRightNum) {
                left = maxLeftNum;
                right = maxRightNum > (this.btnNum - left - 1) ? this.btnNum - left - 1 : maxRightNum;
            }
            else {
                left = maxLeftNum;
                right = maxRightNum;
            }
        }
        for (var i = 0; i < left; i++) {
            this.pages.push(pagination.page - left + i);
        }
        this.pages.push(pagination.page);
        for (var i = 0; i < right; i++) {
            this.pages.push(pagination.page + i + 1);
        }
    };
    PaginationComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-pagination',
                    template: "<div class=\"d-inline-block\">\n    <ng-container *ngIf=\"goTitle\">\n        <button (click)=\"page.invalid||sendChange(page.value)\" [class]=\"btnClass\">{{goTitle}}</button>\n        <input ngModel #page=\"ngModel\" [min]=\"1\" [class.form-control-sm]=\"!(sm===null||sm==='false')\"\n        [class.form-control-lg]=\"!(lg===null||lg==='false')\"\n            class=\"form-control pagination-input form-sm-control border-muted ml-1 mr-1\" type=\"number\">\n    </ng-container>\n    <ts-dropdown *ngIf=\"items\" dropup [page]=\"outline\" [lg]=\"lg\" [sm]=\"sm\" [color]=\"color\" [outline]=\"outline\"\n    [value]=\"pagination.limit\" [items]=\"items\" (valueChange)=\"changeLimit($event)\" class=\"mr-1\"></ts-dropdown>\n    <div class=\"btn-group mr-2\" role=\"group\">\n        <button type=\"button\" [class]=\"btnClass\" *ngIf=\"!!startTitle\" [class.disabled]=\"!pagination.hasPrev()\"\n        [disabled]=\"!pagination.hasPrev()\"\n            (click)=\"pagination.page=1;sendChange()\">{{startTitle}}</button>\n        <button type=\"button\" [class]=\"btnClass\" *ngIf=\"!!prevTitle\" [class.disabled]=\"!pagination.hasPrev()\"\n        [disabled]=\"!pagination.hasPrev()\"\n            (click)=\"pagination.page=pagination.page-1;sendChange()\">{{prevTitle}}</button>\n        <ng-template ngFor let-item [ngForOf]=\"pages\" let-i=\"index\">\n            <button [ngClass]=\"{'active':item == pagination.page}\" type=\"button\" [class]=\"btnClass\"\n            (click)=\"pagination.page=item;sendChange()\">{{item}}</button>\n        </ng-template>\n        <button type=\"button\" [class]=\"btnClass\" *ngIf=\"!!nextTitle\" [class.disabled]=\"!pagination.hasNext()\"\n        [disabled]=\"!pagination.hasNext()\"\n            (click)=\"pagination.page=pagination.page+1;sendChange()\">{{nextTitle}}</button>\n        <button type=\"button\" [class]=\"btnClass\" *ngIf=\"!!endTitle\" [class.disabled]=\"!pagination.hasNext()\"\n        [disabled]=\"!pagination.hasNext()\"\n            (click)=\"pagination.page=pagination.maxPage;sendChange()\">{{endTitle}}</button>\n    </div>\n</div>",
                    styles: [
                        ".pagination-input {\n            width: 70px;\n            display: inline-block !important;\n            vertical-align: middle;\n            border-color: #eee !important;\n        }\n        .btn-outline-primary,\n        .btn-outline-secondary,\n        .btn-outline-success,\n        .btn-outline-danger,\n        .btn-outline-warning,\n        .btn-outline-info,\n        .btn-outline-dark{\n            border-color: #eee;\n        }\n\n        .btn-outline-primary.disabled:hover,\n        .btn-outline-secondary.disabled:hover,\n        .btn-outline-success.disabled:hover,\n        .btn-outline-danger.disabled:hover,\n        .btn-outline-warning.disabled:hover,\n        .btn-outline-info.disabled:hover,\n        .btn-outline-dark.disabled:hover{\n            border-color: #eee !important;\n        }\n\n        .btn-outline-primary:hover {\n            border-color: #007bff !important;\n        }\n        .btn-outline-secondary:hover {\n            border-color: #6c757d !important;\n        }\n        .btn-outline-success:hover {\n            border-color: #28a745 !important;\n        }\n        .btn-outline-danger:hover {\n            border-color: #dc3545 !important;\n        }\n        .btn-outline-warning:hover {\n            border-color: #ffc107 !important;\n        }\n        .btn-outline-info:hover {\n            border-color: #17a2b8 !important;\n        }\n        .btn-outline-dark:hover {\n            border-color: #343a40 !important;\n        }"
                    ]
                },] },
    ];
    /** @nocollapse */
    PaginationComponent.ctorParameters = function () { return []; };
    PaginationComponent.propDecorators = {
        "nextTitle": [{ type: core_1.Input },],
        "prevTitle": [{ type: core_1.Input },],
        "endTitle": [{ type: core_1.Input },],
        "startTitle": [{ type: core_1.Input },],
        "pagination": [{ type: core_1.Input },],
        "btnNum": [{ type: core_1.Input },],
        "items": [{ type: core_1.Input },],
        "goTitle": [{ type: core_1.Input },],
        "pageChange": [{ type: core_1.Output },],
    };
    return PaginationComponent;
}(attr_class_1.DomAttr));
exports.PaginationComponent = PaginationComponent;
//# sourceMappingURL=pagination.component.js.map