"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("../../commons/extends/attr.class");
var dropdown_directive_1 = require("../dropdown/dropdown.directive");
var forms_1 = require("@angular/forms");
var SelectsComponent = /** @class */ (function (_super) {
    __extends(SelectsComponent, _super);
    function SelectsComponent(elementRef) {
        var _this = _super.call(this) || this;
        _this.elementRef = elementRef;
        // @Output() valuesChange = new EventEmitter<any>(false);
        _this.optionChange = new core_1.EventEmitter(false);
        _this.applyChange = function (value) { };
        _this.placeholder = 'Select...';
        _this.searchKey = '';
        _this.title = '';
        _this.items = [];
        _this.activeItems = [];
        _this.emptyLabel = 'No results found.';
        _this.searchLabel = 'Search...';
        _this.changeInside = false;
        return _this;
    }
    Object.defineProperty(SelectsComponent.prototype, "searchItems", {
        get: function () {
            var _this = this;
            var items = this.items;
            if (this.searchKey) {
                items = items.filter(function (e) { return e.text.indexOf(_this.searchKey) > -1; });
            }
            return items;
        },
        enumerable: true,
        configurable: true
    });
    // ngOnChanges() {
    //     if (this.changeInside) {
    //         this.changeInside = false;
    //     }
    //     this.activeItems = [];
    //     this.values.forEach(value => {
    //         const temp = this.items.find(item => item.value === value);
    //         if (temp !== undefined) {
    //             this.activeItems.push(temp);
    //         }
    //     });
    // }
    // ngOnChanges() {
    //     if (this.changeInside) {
    //         this.changeInside = false;
    //     }
    //     this.activeItems = [];
    //     this.values.forEach(value => {
    //         const temp = this.items.find(item => item.value === value);
    //         if (temp !== undefined) {
    //             this.activeItems.push(temp);
    //         }
    //     });
    // }
    SelectsComponent.prototype.ngAfterViewInit = 
    // ngOnChanges() {
    //     if (this.changeInside) {
    //         this.changeInside = false;
    //     }
    //     this.activeItems = [];
    //     this.values.forEach(value => {
    //         const temp = this.items.find(item => item.value === value);
    //         if (temp !== undefined) {
    //             this.activeItems.push(temp);
    //         }
    //     });
    // }
    function () {
        var dom = this.elementRef.nativeElement;
        dom.classList.add('form-control', 'p-0');
        if (this.sm !== null) {
            dom.classList.add('form-control-sm');
        }
        if (this.lg !== null) {
            dom.classList.add('form-control-lg');
        }
    };
    SelectsComponent.prototype.writeValue = function (values) {
        var _this = this;
        if (values === null || values === undefined) {
            values = [];
        }
        this.values = values;
        if (this.changeInside) {
            this.changeInside = false;
        }
        this.activeItems = [];
        this.values.forEach(function (value) {
            var temp = _this.items.find(function (item) { return item.value === value; });
            if (temp !== undefined) {
                _this.activeItems.push(temp);
            }
        });
    };
    SelectsComponent.prototype.registerOnChange = function (fn) { this.applyChange = fn; };
    SelectsComponent.prototype.registerOnTouched = function (fn) { };
    SelectsComponent.prototype.cleanSearch = function () {
        this.searchKey = '';
    };
    SelectsComponent.prototype.setValue = function (item) {
        var _this = this;
        var index = this.activeItems.indexOf(item);
        if (index < 0) {
            this.activeItems.push(item);
        }
        else {
            this.activeItems.splice(index, 1);
        }
        this.values = this.activeItems.map(function (element) { return element.value; });
        // this.valuesChange.emit(this.values);
        this.applyChange(this.values);
        this.optionChange.emit(this.activeItems);
        setTimeout(function () {
            if (!_this.dropdown.isClose()) {
                _this.dropdown.present();
            }
        });
    };
    SelectsComponent.prototype.isActiveItem = function (item) {
        return this.activeItems.indexOf(item) >= 0;
    };
    SelectsComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: '*[tsSelects]',
                    template: "\n    <div tsDropdown  #tsDropdown=\"tsDropdown\" (displayChange)=\"cleanSearch()\" class=\"w-100\" [useItemClickClose]=\"false\">\n        <div tsToggle\n            [class.p-0]=\"activeItems.length>0\"\n            [class.p-2]=\"activeItems.length<=0\"\n            class=\"pointer w-100\">\n            <span class=\"text-muted\" *ngIf=\"activeItems.length<=0\">{{placeholder}}</span>\n            <span class=\"badge p-2 m-1 no-select {{badgeClass}}\" *ngFor=\"let active of activeItems\">\n                <i (click)=\"setValue(active)\" class=\"fa fa-fw fa-close\"></i>\n                {{active.text}}\n            </span>\n        </div>\n        <div tsDropMenu [style.width]=\"'100%'\">\n            <div class=\"w-100 ts-select-item\">\n                <div class=\"pl-2 pb-2 pr-2\">\n                    <input [(ngModel)]=\"searchKey\" [placeholder]=\"searchLabel\" class=\"form-control\" type=\"text\">\n                </div>\n                <p class=\"text-center\" *ngIf=\"searchItems.length<=0\">{{emptyLabel}}</p>\n                <div *ngFor=\"let item of searchItems\"\n                    (click)=\"setValue(item)\"\n                    class=\"dropdown-item pointer no-select {{isActiveItem(item)?textClass:''}}\">\n                    <div class=\"d-table w-100\">\n                        <div class=\"d-table-cell\" [innerHTML]=\"item.content||item.text\"></div>\n                        <div class=\"d-table-cell text-right\" *ngIf=\"isActiveItem(item)\">\n                            <i class=\"fa fa-fw fa-check\"></i>\n                        </div>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>",
                    styles: [
                        ".ts-select-item {\n            max-height: 270px;\n            overflow-y: auto;\n        }\n        .dropdown-item.active,\n        .dropdown-item:active{\n            color: #343a40 !important;\n            background: #f8f9fa !important;\n        }\n        .dropdown-item:after{\n            text-align:center;\n        }"
                    ],
                    providers: [{
                            provide: forms_1.NG_VALUE_ACCESSOR,
                            useExisting: core_1.forwardRef(function () { return SelectsComponent; }),
                            multi: true
                        }]
                },] },
    ];
    /** @nocollapse */
    SelectsComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    SelectsComponent.propDecorators = {
        "items": [{ type: core_1.Input },],
        "placeholder": [{ type: core_1.Input },],
        "emptyLabel": [{ type: core_1.Input },],
        "searchLabel": [{ type: core_1.Input },],
        "optionChange": [{ type: core_1.Output },],
        "dropdown": [{ type: core_1.ViewChild, args: ['tsDropdown',] },],
    };
    return SelectsComponent;
}(attr_class_1.DomAttr));
exports.SelectsComponent = SelectsComponent;
//# sourceMappingURL=selects.component.js.map