"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ToastComponent = /** @class */ (function () {
    function ToastComponent(config) {
        this.config = config;
        this.maxLength = 5;
        this.dValue = 500;
        this.show = true;
        this.toasts = new Array();
        this.position = this.config.position;
        this.timer = null;
    }
    ToastComponent.prototype.addToast = function (toast) {
        var _this = this;
        if (this.timer === null) {
            this.timer = setInterval(function () {
                _this.checkTimeOut();
            }, this.dValue);
        }
        if (this.toasts.length > this.maxLength) {
            this.toasts.shift();
        }
        this.toasts.push(toast);
        this.show = true;
    };
    ToastComponent.prototype.removeToast = function (toast) {
        this.toasts.splice(this.toasts.indexOf(toast), 1);
    };
    ToastComponent.prototype.checkTimeOut = function () {
        var _this = this;
        this.toasts.forEach(function (toast) {
            toast.cx += _this.dValue;
        });
        this.toasts = this.toasts.filter(function (toast) { return toast.timeout > toast.cx; });
        if (this.toasts.length <= 0) {
            clearInterval(this.timer);
            this.timer = null;
        }
    };
    ToastComponent.prototype.ngOnDestroy = function () {
        if (this.timer !== null) {
            clearInterval(this.timer);
            this.timer = null;
        }
    };
    ToastComponent.decorators = [
        { type: core_1.Component, args: [{
                    template: "\n    <div *ngIf=\"show\" class=\"{{position}} position-fixed alert m-2\" style=\"width:20rem;z-index:9999\">\n        <div *ngFor=\"let toast of toasts\" class=\"alert {{toast.color}}\" [class.ts-op-hidden]=\"(toast.timeout - toast.cx)<=1000\">\n            <h6 class=\"alert-heading\">{{toast.title}}\n                <span (click)=\"removeToast(toast)\" class=\"pointer pull-right\" style=\"opacity: 0.8;\">&times;</span>\n            </h6>\n            <hr class=\"mb-2\">\n            <p class=\"mb-0 mt-0\">{{toast.message}}</p>\n        </div>\n    </div>\n    ",
                    styles: [
                        ".close {\n            cursor:pointer;\n        }\n        .ts-top {\n            top:0\n        }\n        .ts-bottom {\n            bottom:0\n        }\n        .ts-left {\n            left:0\n        }\n        .ts-right {\n            right:0;\n        }\n        .ts-op-hidden{\n            opacity:0;\n            transition: opacity 1s;\n        }\n        ",
                    ]
                },] },
    ];
    /** @nocollapse */
    ToastComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: ['DEFAULT_CONFIG',] },] },
    ]; };
    return ToastComponent;
}());
exports.ToastComponent = ToastComponent;
//# sourceMappingURL=toast.component.js.map