"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var toast_component_1 = require("./toast.component");
var toast_class_1 = require("./toast.class");
var ToastService = /** @class */ (function () {
    function ToastService(applicationRef, componentFactoryResolver, config, injector) {
        this.applicationRef = applicationRef;
        this.componentFactoryResolver = componentFactoryResolver;
        this.config = config;
        this.injector = injector;
    }
    ToastService.prototype.init = function () {
        if (this.baseComponent !== undefined || this.baseComponent != null) {
            return;
        }
        this.baseComponent = this.componentFactoryResolver.resolveComponentFactory(toast_component_1.ToastComponent);
        this.windowCmptRef = this.baseComponent.create(this.injector);
        this.applicationRef.attachView(this.windowCmptRef.hostView);
        var containerEl = document.querySelector('body');
        containerEl.appendChild(this.windowCmptRef.location.nativeElement);
    };
    ToastService.prototype.create = function (title, message, options) {
        this.init();
        this.windowCmptRef.instance.addToast(new toast_class_1.Toast(title, message, options.color, options.timeout || this.config.timeout));
    };
    ToastService.prototype.info = function (title, message, timer) {
        this.create(title, message, { color: 'bg-info text-white', timeout: timer || this.config.timeout });
    };
    ToastService.prototype.success = function (title, message, timer) {
        this.create(title, message, { color: 'bg-success text-white', timeout: timer || this.config.timeout });
    };
    ToastService.prototype.danger = function (title, message, timer) {
        this.create(title, message, { color: 'bg-danger text-white', timeout: timer || this.config.timeout });
    };
    ToastService.prototype.warning = function (title, message, timer) {
        this.create(title, message, { color: 'bg-warning text-dark', timeout: timer || this.config.timeout });
    };
    ToastService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ToastService.ctorParameters = function () { return [
        { type: core_1.ApplicationRef, },
        { type: core_1.ComponentFactoryResolver, },
        { type: undefined, decorators: [{ type: core_1.Inject, args: ['DEFAULT_CONFIG',] },] },
        { type: core_1.Injector, },
    ]; };
    return ToastService;
}());
exports.ToastService = ToastService;
//# sourceMappingURL=toast.service.js.map