"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var attr_class_1 = require("../../commons/extends/attr.class");
var upload_data_1 = require("./upload.data");
var ImageCardComponent = /** @class */ (function (_super) {
    __extends(ImageCardComponent, _super);
    function ImageCardComponent(domSanitizer) {
        var _this = _super.call(this) || this;
        _this.domSanitizer = domSanitizer;
        _this.fileChange = new core_1.EventEmitter(false);
        _this.srcChange = new core_1.EventEmitter(false);
        _this.showImage = false;
        _this.isLoading = false;
        _this.hasUpload = true;
        _this.width = 130;
        _this.default = '';
        _this.title = 'Click...';
        return _this;
    }
    Object.defineProperty(ImageCardComponent.prototype, "source", {
        get: function () { return this.config ? (this.config.host || '') : ''; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCardComponent.prototype, "query", {
        get: function () { return this.config ? (this.config.queryString || '') : ''; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCardComponent.prototype, "realSrc", {
        get: function () {
            return typeof this.src === 'string' ? this.source + this.src + this.query : this.src.blobUrl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCardComponent.prototype, "sizePx", {
        get: function () {
            return this.width + 'px';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCardComponent.prototype, "blockStyle", {
        get: function () {
            return { height: this.sizePx, width: this.sizePx };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCardComponent.prototype, "windowStyle", {
        get: function () {
            return { lineHeight: (this.width - 7) + 'px' };
        },
        enumerable: true,
        configurable: true
    });
    ImageCardComponent.prototype.ngOnChanges = function (changes) {
        if (changes.src && !this.default) {
            this.default = changes.src.currentValue;
        }
    };
    ImageCardComponent.prototype.getUrl = function () {
        return "url(" + this.realSrc + ")";
    };
    ImageCardComponent.prototype.changeFile = function (files) {
        this.hasUpload = false;
        this.isLoading = false;
        this.file = files[0];
        if (files.length > 0) {
            this.fileChange.emit(files[0]);
            this.src = { blobUrl: window.URL.createObjectURL(files[0]) };
            this.showImage = true;
            if (!!this.config) {
                console.log(111);
                if (this.config.uploader) {
                    this.uploadFile();
                }
            }
        }
    };
    ImageCardComponent.prototype.resetInput = function (input) {
        this.showImage = false;
        this.isLoading = false;
        this.hasUpload = true;
        this.file = null;
        input.value = '';
        this.src = this.default || '';
        this.srcChange.emit(this.src);
    };
    ImageCardComponent.prototype.cleanInput = function (input) {
        this.src = '';
        this.showImage = false;
        this.isLoading = false;
        this.hasUpload = true;
        this.file = null;
        input.value = '';
        this.srcChange.emit(this.src);
    };
    ImageCardComponent.prototype.uploadFile = function () {
        var _this = this;
        if (this.hasUpload === true) {
            return;
        }
        if (this.file === null || this.file === undefined) {
            return;
        }
        this.hasUpload = true;
        this.isLoading = true;
        if (this.config.uploader !== undefined || this.config.uploader !== null) {
            this.config.uploader(this.file).subscribe(function (src) {
                _this.isLoading = false;
                _this.src = src;
                _this.srcChange.emit(src);
            });
        }
    };
    ImageCardComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-image-card',
                    template: "\n    <div class=\"d-inline-block rounded border border-muted p-1 mb-1 align-top\" [ngStyle]=\"blockStyle\">\n        <input #input_file class=\"d-none\" type=\"file\" accept=\"image/*\" (change)=\"changeFile($event.target.files);input_file.value=null\">\n        <div  *ngIf=\"!((!showImage&&!src)||isLoading)\" class=\"w-100 h-100 upload-block\" [ngStyle]=\"{'background-image': getUrl()}\">\n            <div class=\"upload-block-window text-white text-center h-100 w-100\" [ngStyle]=\"windowStyle\">\n                <!--<i class=\"fa fa-fw fa-lg fa-eye pointer\"></i>-->\n                <i (click)=\"cleanInput(input_file)\" class=\"fa fa-fw fa-lg fa-trash pointer\"></i>\n            </div>\n        </div>\n        <div *ngIf=\"(!showImage&&!src)&&!isLoading\" (click)=\"input_file.click()\" class=\"w-100 h-100 upload-block\">\n            <div class=\"text-muted text-center h-100 w-100 pointer\" [ngStyle]=\"windowStyle\">\n                <i class=\"fa fa-fw fa-lg fa-picture-o\"></i>{{title}}\n            </div>\n        </div>\n        <div *ngIf=\"isLoading\" class=\"w-100 h-100\">\n            <div class=\"typing_loader\"></div>\n        </div>\n    </div>",
                    styles: [upload_data_1.styleStr]
                },] },
    ];
    /** @nocollapse */
    ImageCardComponent.ctorParameters = function () { return [
        { type: platform_browser_1.DomSanitizer, },
    ]; };
    ImageCardComponent.propDecorators = {
        "config": [{ type: core_1.Input },],
        "src": [{ type: core_1.Input },],
        "title": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "fileChange": [{ type: core_1.Output },],
        "srcChange": [{ type: core_1.Output },],
    };
    return ImageCardComponent;
}(attr_class_1.DomAttr));
exports.ImageCardComponent = ImageCardComponent;
//# sourceMappingURL=image-card.component.js.map