"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var input_images_class_1 = require("./input-images.class");
var attr_class_1 = require("../../commons/extends/attr.class");
var upload_data_1 = require("./upload.data");
var ImageCardsComponent = /** @class */ (function (_super) {
    __extends(ImageCardsComponent, _super);
    function ImageCardsComponent(domSanitizer) {
        var _this = _super.call(this) || this;
        _this.domSanitizer = domSanitizer;
        _this.srcChange = new core_1.EventEmitter(false);
        _this.fileChange = new core_1.EventEmitter(false);
        _this.deleteChange = new core_1.EventEmitter(false);
        _this.noInputChange = false;
        _this.images = new input_images_class_1.InputImages();
        _this.uploading = false;
        _this.title = 'Click...';
        _this.src = '';
        _this.config = { host: '' };
        _this.default = '';
        _this.width = 130;
        return _this;
    }
    Object.defineProperty(ImageCardsComponent.prototype, "source", {
        get: function () { return this.config ? (this.config.host || '') : ''; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCardsComponent.prototype, "query", {
        get: function () { return this.config ? (this.config.queryString || '') : ''; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCardsComponent.prototype, "sizePx", {
        get: function () {
            return this.width + 'px';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCardsComponent.prototype, "blockStyle", {
        get: function () {
            return { height: this.sizePx, width: this.sizePx };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCardsComponent.prototype, "windowStyle", {
        get: function () {
            return { lineHeight: (this.width - 7) + 'px' };
        },
        enumerable: true,
        configurable: true
    });
    ImageCardsComponent.prototype.ngOnChanges = function (changes) {
        if (!this.uploading) {
            if (changes.src && !this.default) {
                this.default = changes.src.currentValue;
            }
            if (this.noInputChange) {
                this.noInputChange = false;
                return;
            }
            this.images = new input_images_class_1.InputImages(this.src);
        }
    };
    ImageCardsComponent.prototype.changeFile = function (files) {
        for (var i = 0; i < files.length; i++) {
            var url = window.URL.createObjectURL(files[i]);
            this.images.push({ type: 'file', file: files[i], url: url, uploading: !!this.config.uploader });
            this.fileChange.emit(files);
        }
        if (this.config.uploader) {
            this.uploadImage();
        }
    };
    ImageCardsComponent.prototype.getUrl = function (image) {
        if (image.type === 'file') {
            return "url(" + image.url + ")";
        }
        else {
            return "url(" + (image.url ? this.source + image.url + this.query : '');
        }
    };
    ImageCardsComponent.prototype.removeImage = function (index) {
        this.noInputChange = true;
        this.deleteChange.emit(this.images.items[index]);
        this.images.remove(index);
        this.srcChange.emit(this.images.urls.join());
    };
    ImageCardsComponent.prototype.uploadImage = function () {
        var _this = this;
        var fileItems = this.images.fileItems;
        var cx = 0;
        this.uploading = true;
        var _loop_1 = function (i) {
            this_1.config.uploader(fileItems[i].file).subscribe(function (res) {
                fileItems[i].type = 'url';
                fileItems[i].uploading = false;
                fileItems[i].file = null;
                fileItems[i].url = res;
                _this.srcChange.emit(_this.images.urls.join());
                if (++cx === fileItems.length) {
                    _this.uploading = false;
                }
            });
        };
        var this_1 = this;
        for (var i = 0; i < fileItems.length; i++) {
            _loop_1(i);
        }
    };
    ImageCardsComponent.prototype.resetInput = function (input) {
        this.src = this.default;
        this.images = new input_images_class_1.InputImages(this.src);
        input.value = '';
        this.uploading = false;
        this.srcChange.emit(this.images.urls.join());
    };
    ImageCardsComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-image-cards',
                    template: "\n    <div class=\"w-100\">\n        <input #input_file class=\"d-none\" type=\"file\" multiple=\"multiple\"\n         accept=\"image/*\" (change)=\"changeFile($event.target.files);input_file.value=null\">\n        <div *ngFor=\"let item of images.items;index as i\"  class=\"d-inline-block rounded border border-muted p-1 mr-1 mb-1 align-top\"\n            [ngStyle]=\"blockStyle\">\n            <div *ngIf=\"!item.uploading\" class=\"w-100 h-100 upload-block\" [ngStyle]=\"{'background-image': getUrl(item)}\">\n                <div class=\"upload-block-window text-white text-center h-100 w-100\" [ngStyle]=\"windowStyle\">\n                    <i (click)=\"removeImage(i)\" class=\"fa fa-fw fa-lg fa-trash pointer\"></i>\n                </div>\n            </div>\n            <div *ngIf=\"item.uploading\" class=\"span w-100 h-100\">\n                <div class=\"typing_loader\"></div>\n            </div>\n        </div><div class=\"d-inline-block rounded border border-muted p-1 mb-1 align-top\" [ngStyle]=\"blockStyle\">\n            <div (click)=\"input_file.click()\" class=\"w-100 h-100 upload-block\">\n                <div class=\"text-muted text-center h-100 w-100 pointer\" [ngStyle]=\"windowStyle\">\n                    <i class=\"fa fa-fw fa-lg fa-picture-o\"></i>{{title}}\n                </div>\n            </div>\n        </div>\n    </div>\n    ",
                    styles: [upload_data_1.styleStr]
                },] },
    ];
    /** @nocollapse */
    ImageCardsComponent.ctorParameters = function () { return [
        { type: platform_browser_1.DomSanitizer, },
    ]; };
    ImageCardsComponent.propDecorators = {
        "src": [{ type: core_1.Input },],
        "title": [{ type: core_1.Input },],
        "config": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "srcChange": [{ type: core_1.Output },],
        "fileChange": [{ type: core_1.Output },],
        "deleteChange": [{ type: core_1.Output },],
    };
    return ImageCardsComponent;
}(attr_class_1.DomAttr));
exports.ImageCardsComponent = ImageCardsComponent;
//# sourceMappingURL=image-cards.component.js.map