"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var InputFileDirective = /** @class */ (function () {
    function InputFileDirective(elementRef) {
        this.elementRef = elementRef;
        this.fileChange = new core_1.EventEmitter();
        this.type = 'file';
    }
    InputFileDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.inputDom = this.elementRef.nativeElement;
        this.inputDom.style.display = 'none';
        this.inputDom.addEventListener('change', function () {
            if (_this.isMultiple()) {
                var files = new Array();
                for (var i = 0; i < _this.inputDom.files.length; i++) {
                    files.push(_this.inputDom.files[i]);
                }
                _this.fileChange.emit(files);
            }
            else {
                _this.fileChange.emit(_this.inputDom.files[0]);
            }
            _this.inputDom.value = '';
        });
    };
    InputFileDirective.prototype.openFileDialog = function () {
        this.elementRef.nativeElement.click();
    };
    InputFileDirective.prototype.removeFile = function () {
        this.elementRef.nativeElement.value = '';
        this.fileChange.emit(null);
    };
    InputFileDirective.prototype.isMultiple = function () {
        return this.inputDom.multiple === true;
    };
    InputFileDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: "input[tsFile]",
                    exportAs: 'tsFile'
                },] },
    ];
    /** @nocollapse */
    InputFileDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    InputFileDirective.propDecorators = {
        "fileChange": [{ type: core_1.Output },],
        "type": [{ type: core_1.HostBinding, args: ['type',] },],
    };
    return InputFileDirective;
}());
exports.InputFileDirective = InputFileDirective;
//# sourceMappingURL=input-file.directive.js.map