"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var attr_class_1 = require("../../commons/extends/attr.class");
var InputVideoComponent = /** @class */ (function (_super) {
    __extends(InputVideoComponent, _super);
    function InputVideoComponent(sanitizer) {
        var _this = _super.call(this) || this;
        _this.sanitizer = sanitizer;
        _this.fileChange = new core_1.EventEmitter();
        _this.srcChange = new core_1.EventEmitter();
        _this.showVideo = false;
        _this.showLoading = false;
        _this.hasUpload = false;
        _this.loaded = '0%';
        _this.type = 'video';
        _this.videoSize = ['250px', '180px'];
        _this.autoUpload = false;
        _this.useUpload = false;
        return _this;
    }
    Object.defineProperty(InputVideoComponent.prototype, "source", {
        get: function () { return this.config ? (this.config.host || '') : ''; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputVideoComponent.prototype, "realSrc", {
        get: function () { return typeof this.src === 'string' ? this.source + this.src : this.src; },
        enumerable: true,
        configurable: true
    });
    InputVideoComponent.prototype.ngOnChanges = function (changes) {
        if (changes.src && changes.src.currentValue) {
            this.showVideo = true;
            this.src = !changes.src.firstChange ? changes.src.currentValue : this.src;
        }
    };
    InputVideoComponent.prototype.changeFile = function (files) {
        if (files.length > 0) {
            this.file = files[0];
            this.fileChange.emit(files[0]);
            this.src = this.sanitizer.bypassSecurityTrustResourceUrl(window.URL.createObjectURL(files[0]));
            this.showVideo = true;
            this.hasUpload = false;
            this.showLoading = false;
            if (!!this.config && this.config.progresser && !this.useUpload) {
                this.tryUpload();
            }
        }
    };
    InputVideoComponent.prototype.cleanInput = function () {
        if (this.showLoading && this.subscription) {
            this.subscription.unsubscribe();
            this.subscription = null;
            this.showLoading = false;
        }
        else {
            this.src = '';
            this.showVideo = false;
            this.hasUpload = true;
            this.file = null;
            this.fileChange.emit(null);
        }
    };
    InputVideoComponent.prototype.tryUpload = function () {
        var _this = this;
        if (this.hasUpload === true) {
            return;
        }
        if (this.file === null || this.file === undefined) {
            return;
        }
        this.hasUpload = true;
        this.loaded = '0%';
        this.subscription = this.config.progresser(this.file).subscribe(function (res) {
            if (typeof res === 'string') {
                _this.src = res;
                _this.showLoading = false;
                _this.srcChange.emit(res);
            }
            else {
                _this.loaded = res + '%';
            }
        });
        this.showLoading = true;
    };
    InputVideoComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-video',
                    template: "\n    <div class=\"d-inline-block align-top\">\n        <input #input_file type=\"file\" class=\"d-none\"\n            [attr.accept]=\"type+'/*'\" (change)=\"changeFile($event.target.files);input_file.value=null\">\n        <div class=\"btn-group mb-1\" role=\"group\">\n            <button [class]=\"btnClass\" (click)=\"input_file.click()\" type=\"button\">\n                <i class=\"fa fa-folder-open-o fa-fw fa-lg\" aria-hidden=\"true\"></i>{{title||'OpenFile'}}</button>\n            <button *ngIf=\"useUpload&&!autoUpload\" [class]=\"btnClass\" (click)=\"tryUpload()\" type=\"button\">\n                <i class=\"fa fa-upload fa-fw fa-lg\" aria-hidden=\"true\"></i>\n            </button>\n            <button [class]=\"btnClass\" (click)=\"cleanInput()\" type=\"button\">\n                <i class=\"fa fa-remove fa-fw\" aria-hidden=\"true\"></i>\n            </button>\n        </div>\n        <br>\n        <div *ngIf=\"showVideo&&!showLoading&&type!=='audio'\"\n            [style.width]=\"videoSize[0]\" [style.height]=\"videoSize[1]\" class=\"d-inline-block\">\n            <video class=\"m-0 p-0 rounded-0 border border-muted w-100 h-100\" [src]=\"realSrc\" controls=\"true\"></video>\n        </div>\n        <div *ngIf=\"showVideo&&!showLoading&&type==='audio'\"\n            [style.width]=\"videoSize[0]\" [style.height]=\"videoSize[1]\" class=\"border border-muted d-inline-block\">\n            <audio class=\"m-0 p-0 rounded-0 w-100\" [src]=\"realSrc\" controls=\"true\"></audio>\n        </div>\n        <div *ngIf=\"showLoading\"\n            [style.width]=\"videoSize[0]\" [style.width]=\"videoSize[0]\" [style.height]=\"videoSize[1]\" class=\"d-inline-block\">\n            <div class=\"w-100 h-100\">\n                <div class=\"progress w-100 d-inline-block\">\n                    <div class=\"progress-bar bg-{{color}} progress-bar-striped progress-bar-animated\" [style.width]=\"loaded\">\n                        {{loaded}}\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>",
                },] },
    ];
    /** @nocollapse */
    InputVideoComponent.ctorParameters = function () { return [
        { type: platform_browser_1.DomSanitizer, },
    ]; };
    InputVideoComponent.propDecorators = {
        "src": [{ type: core_1.Input },],
        "videoSize": [{ type: core_1.Input },],
        "title": [{ type: core_1.Input },],
        "type": [{ type: core_1.Input },],
        "autoUpload": [{ type: core_1.Input },],
        "useUpload": [{ type: core_1.Input },],
        "config": [{ type: core_1.Input },],
        "fileChange": [{ type: core_1.Output },],
        "srcChange": [{ type: core_1.Output },],
    };
    return InputVideoComponent;
}(attr_class_1.DomAttr));
exports.InputVideoComponent = InputVideoComponent;
//# sourceMappingURL=input-video.component.js.map