"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var chart_config_1 = require("./chart.config");
var BarChartDirective = /** @class */ (function () {
    function BarChartDirective(elementRef) {
        var _this = this;
        this.elementRef = elementRef;
        this.datas = new Array();
        this.colors = new Array();
        this.labels = new Array();
        this.xlabels = new Array();
        chart_config_1.DefaultChartColor.backgroundColor.forEach(function (e, i) {
            _this.colors.push({
                backgroundColor: e,
                borderColor: chart_config_1.DefaultChartColor.borderColor[i],
                borderWidth: chart_config_1.DefaultChartColor.borderWidth,
            });
        });
        this.type = 'bar';
        this.ready = false;
        this.options = {};
    }
    BarChartDirective.prototype.ngOnChanges = function (change) {
        this.updateChart();
    };
    BarChartDirective.prototype.ngAfterViewInit = function () {
        this.canvas = this.elementRef.nativeElement;
        this.chart = new window.Chart(this.canvas, { type: this.type });
        this.ready = true;
        this.updateChart();
    };
    BarChartDirective.prototype.updateChart = function () {
        var _this = this;
        if (this.ready) {
            var datasets_1 = new Array();
            this.datas.forEach(function (data, i) {
                datasets_1.push({
                    label: _this.labels[i],
                    data: _this.datas[i],
                    backgroundColor: _this.colors[i].backgroundColor,
                    borderColor: _this.colors[i].borderColor,
                    borderWidth: _this.colors[i].borderWidth,
                });
            });
            this.chart.data = {
                labels: this.xlabels,
                datasets: datasets_1,
                options: this.options,
            };
            this.chart.update();
        }
    };
    BarChartDirective.prototype.toBase64Image = function () {
        return this.ready ? this.chart.toBase64Image() : '';
    };
    BarChartDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: 'canvas[barChart]',
                    exportAs: 'barChart',
                },] },
    ];
    /** @nocollapse */
    BarChartDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    BarChartDirective.propDecorators = {
        "datas": [{ type: core_1.Input },],
        "colors": [{ type: core_1.Input },],
        "labels": [{ type: core_1.Input },],
        "xlabels": [{ type: core_1.Input },],
        "options": [{ type: core_1.Input },],
    };
    return BarChartDirective;
}());
exports.BarChartDirective = BarChartDirective;
//# sourceMappingURL=bar-chart.directive.js.map