"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var script_service_1 = require("./../../commons/services/script.service");
var CkeditorComponent = /** @class */ (function () {
    function CkeditorComponent(script, srcs) {
        this.script = script;
        this.srcs = srcs;
        this.load = new core_1.EventEmitter();
        this.contentChange = new core_1.EventEmitter();
        this.content = '';
        this.options = {};
    }
    CkeditorComponent.prototype.ngOnChanges = function (change) {
        this.updateContent();
    };
    CkeditorComponent.prototype.ngOnInit = function () {
        this.script.loads(this.srcs, !!window.ClassicEditor);
    };
    CkeditorComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.textarea = this.editor.nativeElement;
        this.script.complete(function () {
            window.ClassicEditor
                .create(_this.textarea, _this.options)
                .then(function (editor) {
                _this.editroHandle = editor;
                _this.ready = true;
                _this.load.emit(_this.editroHandle);
                _this.updateContent();
            })
                .catch(function (error) {
                console.error(error);
            });
        });
    };
    CkeditorComponent.prototype.updateContent = function () {
        if (this.ready) {
            this.editroHandle.setData(this.content);
        }
    };
    CkeditorComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-ckeditor',
                    exportAs: 'tsCkeditor',
                    template: "<div #editor></div>",
                    styles: [],
                    encapsulation: core_1.ViewEncapsulation.Emulated,
                },] },
    ];
    /** @nocollapse */
    CkeditorComponent.ctorParameters = function () { return [
        { type: script_service_1.ScriptService, },
        { type: Array, decorators: [{ type: core_1.Inject, args: ['CKEDITOR_SCRIPT_SRCS',] },] },
    ]; };
    CkeditorComponent.propDecorators = {
        "editor": [{ type: core_1.ViewChild, args: ['editor',] },],
        "content": [{ type: core_1.Input },],
        "options": [{ type: core_1.Input },],
        "load": [{ type: core_1.Output },],
        "contentChange": [{ type: core_1.Output },],
    };
    return CkeditorComponent;
}());
exports.CkeditorComponent = CkeditorComponent;
//# sourceMappingURL=ckeditor.component.js.map