"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var script_service_1 = require("./../../commons/services/script.service");
var BaseEchartDirective = /** @class */ (function () {
    function BaseEchartDirective(script, elementRef, src) {
        var _this = this;
        this.script = script;
        this.elementRef = elementRef;
        this.src = src;
        this.chartLoad = new core_1.EventEmitter();
        this.resizeChart = function () {
            _this.echart.resize();
        };
        this.resize = false;
    }
    BaseEchartDirective.prototype.ngOnInit = function () {
        this.script.load(this.src, window.echarts);
    };
    BaseEchartDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.script.complete(function () {
            _this.echart = window.echarts.init(_this.elementRef.nativeElement);
            _this.echart.setOption(_this.option);
            _this.chartLoad.emit(_this.echart);
            if (_this.resize) {
                window.addEventListener('resize', _this.resizeChart);
            }
            setTimeout(function () { return _this.echart.resize(); }, 2000);
        });
    };
    BaseEchartDirective.prototype.ngOnDestroy = function () {
        window.removeEventListener('resize', this.resizeChart);
    };
    BaseEchartDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: 'div[baseEchart]',
                    exportAs: 'baseEchart',
                },] },
    ];
    /** @nocollapse */
    BaseEchartDirective.ctorParameters = function () { return [
        { type: script_service_1.ScriptService, },
        { type: core_1.ElementRef, },
        { type: undefined, decorators: [{ type: core_1.Inject, args: ['ECHART_SCRIPT_SRC',] },] },
    ]; };
    BaseEchartDirective.propDecorators = {
        "option": [{ type: core_1.Input },],
        "resize": [{ type: core_1.Input },],
        "chartLoad": [{ type: core_1.Output },],
    };
    return BaseEchartDirective;
}());
exports.BaseEchartDirective = BaseEchartDirective;
//# sourceMappingURL=echart.directive.js.map