"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var rxjs_1 = require("rxjs");
var map_config_1 = require("./map.config");
var MapService = /** @class */ (function () {
    function MapService(mapConfig) {
        var _this = this;
        this.mapConfig = mapConfig;
        this.ready = false;
        var sub = new rxjs_1.Subject();
        this.loadHandle = sub.asObservable();
        if (!window.AMap) {
            window.aMapLoadCallBack = function () {
                _this.amap = window.AMap;
                _this.ready = true;
                sub.next(window.AMap);
                sub.complete();
            };
            var node = document.createElement('script');
            node.async = true;
            node.type = 'text/javascript';
            node.src = "https://webapi.amap.com/maps?v=1.4.3&key=" + mapConfig.appKey + "&callback=aMapLoadCallBack";
            node.charset = 'utf-8';
            document.getElementsByTagName('head')[0].appendChild(node);
        }
        else {
            this.ready = true;
        }
        console.log('load js');
    }
    MapService.prototype.doFuc = function (func) {
        var _this = this;
        if (this.ready) {
            func(this.amap);
        }
        else {
            this.loadHandle.subscribe({ complete: function () { return func(_this.amap); } });
        }
    };
    MapService.prototype.getPositionByAddress = function (address) {
        var sub = new rxjs_1.Subject();
        this.doFuc(function () {
            window.AMap.service('AMap.Geocoder', function () {
                var geocoder = new window.AMap.Geocoder({});
                geocoder.getLocation(address, function (status, result) {
                    if (status === 'complete' && result.info === 'OK') {
                        sub.next({ result: true, datas: result });
                    }
                    else {
                        sub.next({ result: false, datas: result });
                    }
                    sub.complete();
                });
            });
        });
        return sub.asObservable();
    };
    MapService.prototype.geometryUtil = function (callback) {
        this.doFuc(function (amap) {
            callback(amap.GeometryUtil, amap);
        });
    };
    MapService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    MapService.ctorParameters = function () { return [
        { type: map_config_1.MapConfig, },
    ]; };
    return MapService;
}());
exports.MapService = MapService;
//# sourceMappingURL=map.service.js.map